sets  i;


Parameter   BBIM,
            NB,
            OI;

$GDXIN D:\papers\MatToGams.gdx
$load i
$load BBIM
$load NB
$load OI
$GDXIN

alias(i,j);
alias(i,k);

*display j, i;
*$exit

Variable BestPos;
Integer Variables
pos(i);

Integer Variables
x(i,j),
y(i,j);

pos.lo(i)=1;
pos.up(i)=NB;

Equations
Obj,
LowerBound,
UpperBound,
Direction,
NoRepeat1, NoRepeat2, NoRepeat3;

Obj..
BestPos =e= sum(i,OI(i)*pos(i));


LowerBound(i)..
pos(i) =g= 1;

UpperBound(i)..
pos(i) =l= NB;

Direction(i,j)$(BBIM(i,j)>0)..
pos(i) =l= pos(j);
*display BBIM
*$exit

*NoRepeat(i,j)..
*power(pos(i),2)-2*pos(i)*pos(j)+power(pos(j),2) =g= 1;

*------------------------------------------
NoRepeat1(i,j)$(ord(i)>ord(j) or ord(j)<ord(i))..
pos(i)- pos(j)-1 =g= -NB*x(i,j);

NoRepeat2(i,j)$(ord(i)>ord(j) or ord(j)<ord(i))..
pos(i)- pos(j)+1 =l= NB*y(i,j);

NoRepeat3(i,j)$(ord(i)>ord(j) or ord(j)<ord(i))..
x(i,j)+y(i,j) =l= 1;
*------------------------------------------




Model BestPosFinder     /Obj, Direction, NoRepeat1, NoRepeat2, NoRepeat3/;

*solve BestPosFinder minimizing BestPos using mip
option mip=cplex;
option OptCr=0.0;
option reslim=200;
Solve BestPosFinder using mip minimizing BestPos;

display pos.l

